#ifndef VIDEOLAUNCHER_H
#define VIDEOLAUNCHER_H

#include <QObject>

class QUrl;
class QString;

class VideoLauncher : public QObject
{
    Q_OBJECT

public:
    explicit VideoLauncher(QObject *parent = 0);
    inline QString mediaPlayer() const { return m_mediaplayer; }
    inline QString customCommand() const { return m_command; }
        
public slots:
    void setMediaPlayer(const QString &player);
    void setCustomCommand(const QString &command);
    void launchVideo(const QUrl &url);

private:
    QString m_mediaplayer;
    QString m_command;
};

#endif // VIDEOLAUNCHER_H
